#pragma once

#include <vector>
#include <unordered_map>
#include <string>
#include "Matrix.hpp"
#include "Mesh3D.hpp"

namespace cg_engine {
	class Node {
		private:
			Matrix statematrix;
			Mesh3D *mesh;
			std::vector<Node*> childs;
		public:
			Node();
			~Node();
			void setMesh(Mesh3D *m);
			void updateMatrix(Matrix m, bool childs);
			void addChild(Node *h);
			void draw();
			Matrix getMatrix();
	};

	class Hierarchy3D {
		private:
			Node *root;
		public:
			Hierarchy3D();
			~Hierarchy3D();
			void addNode(std::string id, Node *n);
			Node* getNode(std::string id);
			std::unordered_map<std::string, Node*> all_nodes;
	};
}
