#pragma once

#include "CGengine.hpp"
#include "actor.hpp"

using namespace cg_engine;

class IntroScene: public Scene{
	public:
		IntroScene(Config *conf, int w, int h);
		void show(double time);
	private:
		ShaderProgram *def;
		Sprite *layout;
		GLuint layouttex;
};

class HomeScene: public Scene{
	public:
		HomeScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		ShaderProgram *sprite;
		Programmer *programmer;
		Woman *wife;
		GLuint layouttex;
		GLuint mimic[3];
};

class StuffScene: public Scene{
	public:
		StuffScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		GLuint layouttex;

};

class TelephoneScene: public Scene{
	public:
		TelephoneScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		ShaderProgram *sprite;
		GLuint layouttex;
		Woman *wife;

};

class FuneralScene: public Scene{
	public:
		FuneralScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		ShaderProgram *sprite;
		GLuint layouttex;
		Mulder *mulder;
		Scully *scully;
		Widow *widow;
};

class CemetryNightScene: public Scene{
	public:
		CemetryNightScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		ShaderProgram *sprite;
		GLuint layouttex;
		GLuint surprisearm;
};

class CemetryDayScene: public Scene{
	public:
		CemetryDayScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		ShaderProgram *sprite;
		GLuint layouttex;
		Mulder *mulder;
		Scully *scully;
};

class VeryrichOfficeScene: public Scene{
	public:
		VeryrichOfficeScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		ShaderProgram *sprite;
		GLuint layouttex;
		Mulder *mulder;
		Scully *scully;
		Veryrich *veryrich;
};

class OfficeScene: public Scene{
	public:
		OfficeScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		ShaderProgram *sprite;
		GLuint layouttex;
		Mulder *mulder;
		Scully *scully;
		Woman *wife;
};

class AmigaOnDeskScene: public Scene{
	public:
		AmigaOnDeskScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		GLuint layouttex;
};

class ShopScene: public Scene{
	public:
		ShopScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		ShaderProgram *sprite;
		GLuint layouttex;
		Mulder *mulder;
		Scully *scully;
		Shopassistant *shopassistant;

};

class PartyScene: public Scene{
	public:
		PartyScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		ShaderProgram *sprite;
		ShaderProgram *bloodshader;
		GLuint layouttex;
		GLuint deadmouth;
		GLuint deadeye;
		Mulder *mulder;
		Scully *scully;
		Zombie *zombie1;
		Zombie *zombie2;
		Zombie *zombie3;
		Veryrich *veryrich;
		Particle *bloodparticle;
		double zdelta1;
		double zdelta2;
		double zdelta3;
};

class EndcreditScene: public Scene{
	public:
		EndcreditScene(Config *conf, int w, int h);
		void show(double time);
	private:
		Sprite *layout;
		ShaderProgram *def;
		GLuint layouttex;
};

class MyDemo: public Demo{
	public:
		MyDemo(int w, int h);
		void init();
};
